The installation script installs the build server and the bloop command-line application (CLI).
The build server **must be started** before the command-line application is used.

### Running the server in the background

The Homebrew formula installs a Mac OS property list (`plist`) to start up the Bloop server
automatically when you log into your machine. The property list spares you from the cumbersome
process of starting the build server before running any bloop CLI command.

Command examples:

1. `cat /usr/local/var/log/bloop/bloop.out.log`: check the build server logs via stdout.
1. `cat /usr/local/var/log/bloop/bloop.err.log`: check the build server logs via stderr.
1. `brew services start bloop`: starts up the bloop server.
1. `brew services stop bloop`: stops the bloop server.
1. `brew services restart bloop`: restarts the bloop server.

To learn more about `bloop server` and managing the server lifecycle automatically, head to the
[Build Server Reference](docs/server-reference).

### Command-line completions

The installation script automatically installs completions for bash, zsh and fish.

To use them you **need to** set up your shell to source Homebrew-installed completions by following
the [Homebrew Shell Completion](https://docs.brew.sh/Shell-Completion) guide. If you've already
set them up for previous Homebrew packages you can skip the guide.
